## vtk9 9.5.2+dfsg2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12...3.21 FATAL_ERROR)

project(VTK)

if (POLICY CMP0127)
  cmake_policy(SET CMP0127 NEW) # cmake_dependent_option changes
endif ()

if (POLICY CMP0154)
  cmake_policy(SET CMP0154 NEW) # optimize custom commands in PRIVATE filesets
endif ()

set(vtk_cmake_dir "${VTK_SOURCE_DIR}/CMake")
list(INSERT CMAKE_MODULE_PATH 0 "${vtk_cmake_dir}")
include(vtkCI)

if (APPLE)
  include(vtkApple)
endif ()

if (CMAKE_SYSTEM_NAME STREQUAL "Emscripten")
  include(vtkEmscripten)
  if (CMAKE_GENERATOR STREQUAL "Ninja" AND CMAKE_HOST_WIN32)
    # emcc.bat receives too many characters, so use response files instead.
    set(CMAKE_NINJA_FORCE_RESPONSE_FILE 1 CACHE INTERNAL "")
  endif ()
endif ()

# must be before the following iOS / Android
find_package(Git QUIET)
include(VTKDetermineVersion)
include(vtkVersion)
set(VTK_VERSION
    "${VTK_MAJOR_VERSION}.${VTK_MINOR_VERSION}.${VTK_BUILD_VERSION}")
determine_version("${CMAKE_CURRENT_SOURCE_DIR}" "${GIT_EXECUTABLE}" "VTK")

option(VTK_IOS_BUILD "Build vtk.framework for iOS" OFF)
mark_as_advanced(VTK_IOS_BUILD)
if (VTK_IOS_BUILD)
  include(vtkiOS)
  return()
endif()

option(VTK_ANDROID_BUILD "Build VTK for Android" OFF)
mark_as_advanced(VTK_ANDROID_BUILD)
if (VTK_ANDROID_BUILD)
  set(VTK_ANDROID_USER_OPTIONS "" CACHE STRING "CMake options to pass to the android build")
  mark_as_advanced(VTK_ANDROID_USER_OPTIONS)
  include(vtkAndroid)
  return()
endif()

include(vtkCMakeBackports)

option(VTK_WHEEL_BUILD "Build in such a way that Python wheels are supported" OFF)
mark_as_advanced(VTK_WHEEL_BUILD)
if (VTK_WHEEL_BUILD)
  include(vtkWheelPreparation)
endif ()

include(CMakeDependentOption)
# (vtk/vtk#19315) Enable by default after WebGPU support is completed.
option(VTK_ENABLE_WEBGPU "Enable the WebGPU experimental rendering backend." OFF)

include(GNUInstallDirs)

add_library(vtkbuild INTERFACE)
add_library(VTK::vtkbuild ALIAS vtkbuild)

# Some flags are really bad for caching. Replace them with better variants.
if (vtk_replace_uncacheable_flags)
  get_property(is_multiconfig GLOBAL PROPERTY GENERATOR_IS_MULTI_CONFIG)
  if (is_multiconfig)
    string(TOUPPER "${CMAKE_CONFIGURATION_TYPES}" build_types)
  else ()
    string(TOUPPER "${CMAKE_BUILD_TYPE}" build_types)
  endif ()
  foreach (lang IN ITEMS C CXX Fortran)
    foreach (prefix IN ITEMS - /)
      foreach (flag IN ITEMS Zi ZI)
        string(REPLACE "${prefix}${flag}" "-Z7" "CMAKE_${lang}_FLAGS" "${CMAKE_${lang}_FLAGS}")

        foreach (build_type IN LISTS build_types)
          string(REPLACE "${prefix}${flag}" "-Z7" "CMAKE_${lang}_FLAGS_${build_type}" "${CMAKE_${lang}_FLAGS_${build_type}}")
        endforeach ()
      endforeach ()
    endforeach ()
  endforeach ()
endif ()

include(vtkCompilerChecks)
include(vtkCompilerPlatformFlags)
include(vtkCompilerExtraFlags)
include(vtkCompilerWarningFlags)
include(vtkInitializeBuildType)
include(vtkSupportMacros)
include(vtkDownload)
include(vtkSanitize)
include(vtkTesting)
include(vtkMobileDevices)
include(vtkWrapSettings)
include(vtkCrossCompiling)
include(vtkObjectFactory)
include(vtkOpenGLOptions)

option(VTK_RELOCATABLE_INSTALL "Do not embed hard-coded paths into the install" ON)
mark_as_advanced(VTK_RELOCATABLE_INSTALL)
cmake_dependent_option(VTK_UNIFIED_INSTALL_TREE "Assume that the install tree contains all of VTK's dependencies" OFF
  VTK_RELOCATABLE_INSTALL OFF)
mark_as_advanced(VTK_UNIFIED_INSTALL_TREE)

set(CMAKE_INSTALL_LICENSEDIR ""
  CACHE STRING "License files (DATAROOTDIR/licenses/${CMAKE_PROJECT_NAME}")
mark_as_advanced(CMAKE_INSTALL_LICENSEDIR)
if (NOT CMAKE_INSTALL_LICENSEDIR)
  set(CMAKE_INSTALL_LICENSEDIR
    "${CMAKE_INSTALL_DATAROOTDIR}/licenses/${CMAKE_PROJECT_NAME}")
endif ()

set(CMAKE_INSTALL_QMLDIR ""
  CACHE PATH "QML files (LIBDIR/qml)")
mark_as_advanced(CMAKE_INSTALL_QMLDIR)
if (NOT CMAKE_INSTALL_QMLDIR)
  set(CMAKE_INSTALL_QMLDIR
    "${CMAKE_INSTALL_LIBDIR}/qml")
endif ()

# Choose static or shared libraries.
option(BUILD_SHARED_LIBS "Build VTK with shared libraries." ON)
set(VTK_BUILD_SHARED_LIBS ${BUILD_SHARED_LIBS})
set(CMAKE_CXX_VISIBILITY_PRESET "hidden")
set(CMAKE_VISIBILITY_INLINES_HIDDEN 1)
set(CMAKE_POSITION_INDEPENDENT_CODE TRUE)

#-----------------------------------------------------------------------------
# Add the Remote Subdirectory
if (VTK_ENABLE_REMOTE_MODULES)
  add_subdirectory(Remote)
endif ()

#-----------------------------------------------------------------------------
# Does VTK require support for 64 bit file systems
include(CheckCXXSourceRuns)
file(READ "${vtk_cmake_dir}/vtkRequireLargeFilesSupport.cxx"
  VTK_REQUIRE_LARGE_FILE_SUPPORT_FILE)
check_cxx_source_runs("${VTK_REQUIRE_LARGE_FILE_SUPPORT_FILE}"
  VTK_REQUIRE_LARGE_FILE_SUPPORT)

#-----------------------------------------------------------------------------
# Provide compatibility options.
option(VTK_LEGACY_REMOVE "Remove all legacy code completely." OFF)
option(VTK_LEGACY_SILENT "Silence all legacy code messages." OFF)
mark_as_advanced(VTK_LEGACY_REMOVE VTK_LEGACY_SILENT)

include(CheckTypeSize)

option(VTK_USE_MPI "Support MPI" OFF)

option(VTK_SERIAL_TESTS_USE_MPIEXEC "Used on HPC to run serial tests on compute nodes" OFF)
mark_as_advanced(VTK_SERIAL_TESTS_USE_MPIEXEC)

# For platforms that don't support Python threads (do any exist?)
option(VTK_NO_PYTHON_THREADS "Disable Python Threads support" OFF)
mark_as_advanced(VTK_NO_PYTHON_THREADS)
# This setting must be ON for Python concurrency
cmake_dependent_option(VTK_PYTHON_FULL_THREADSAFE "Wrap all Python calls with the GIL" ON
  "NOT VTK_NO_PYTHON_THREADS" OFF)
mark_as_advanced(VTK_PYTHON_FULL_THREADSAFE)

#-----------------------------------------------------------------------------
# Add an option to enable memkind
if (UNIX AND NOT APPLE)
  option(VTK_USE_MEMKIND "Build support for extended memory" OFF)
endif()

#-----------------------------------------------------------------------------
# Add an option to enable/disable components that have CUDA.
option(VTK_USE_CUDA "Support CUDA compilation" OFF)
if(VTK_USE_CUDA)
  # This needs to be a top level flag as enable_language needs
  # to be called from CMake entry point for variables to have
  # the correct scope.
  enable_language(CUDA)
endif()

#-----------------------------------------------------------------------------
# Add an option to enable/disable KOKKOS support.
cmake_dependent_option(VTK_USE_KOKKOS "Support KOKKOS backend accelerator" OFF
  "CMAKE_VERSION VERSION_GREATER_EQUAL 3.21;NOT VTK_USE_CUDA" OFF)
mark_as_advanced(VTK_USE_KOKKOS)
# If the Kokkos backend is set, it should imply that Kokkos is to used
# Note: this behavior is deprecated. Warning issued below.
if(VTK_KOKKOS_BACKEND)
  set(VTK_USE_KOKKOS ON)
endif()

if(VTK_USE_HIP)
  message(WARNING "VTK_USE_HIP will be removed in future releases, please use VTK_USE_KOKKOS with Kokkos built for HIP.")
  set(VTK_USE_KOKKOS ON)
endif()

if(VTK_USE_KOKKOS)
  if(VTK_USE_CUDA)
    message(FATAL_ERROR "VTK_USE_KOKKOS and VTK_USE_CUDA are mutually exclusive, enable only one.")
  endif()
  # This needs to be a top level flag as enable_language needs
  # to be called from CMake entry point for variables to have
  # the correct scope.
  if ("HIP" IN_LIST Kokkos_DEVICES)
    enable_language(HIP)
  endif()
  if ("CUDA" IN_LIST Kokkos_DEVICES)
    enable_language(CUDA)
  endif()
  if (VTK_KOKKOS_BACKEND)
    message(DEPRECATION "Setting VTK_KOKKOS_BACKEND no longer necessary.")
    if (VTK_KOKKOS_BACKEND STREQUAL "HIP")
      enable_language(HIP)
    elseif (VTK_KOKKOS_BACKEND STREQUAL "CUDA")
      enable_language(CUDA)
    elseif (VTK_KOKKOS_BACKEND STREQUAL "SYCL")
    elseif (VTK_KOKKOS_BACKEND STREQUAL "SERIAL")
    else ()
      message(FATAL_ERROR "VTK_KOKKOS_BACKEND `${VTK_KOKKOS_BACKEND}` not recognized")
    endif()
  endif()
endif()

#-----------------------------------------------------------------------------
# Add an option to enable/disable logging support.
option(VTK_ENABLE_LOGGING "Enable logging support." ON)
mark_as_advanced(VTK_ENABLE_LOGGING)

set(VTK_LOGGING_TIME_PRECISION "3"
  CACHE STRING "Precision of loguru scope timers. 3=ms, 6=us, 9=ns")
mark_as_advanced(VTK_LOGGING_TIME_PRECISION)
set(known_logging_precisions 3 6 9)
set_property(CACHE VTK_LOGGING_TIME_PRECISION
  PROPERTY
    STRINGS ${known_logging_precisions})
# Emulate `cmake_dependent_option` for non-bool values.
if (VTK_ENABLE_LOGGING)
  set_property(CACHE VTK_LOGGING_TIME_PRECISION PROPERTY TYPE STRING)
else ()
  set_property(CACHE VTK_LOGGING_TIME_PRECISION PROPERTY TYPE INTERNAL)
  # Use a default value.
  set(VTK_LOGGING_TIME_PRECISION 3)
endif ()
if (NOT VTK_LOGGING_TIME_PRECISION IN_LIST known_logging_precisions)
  string(REPLACE ";" ", " known_logging_precisions_list "${known_logging_precisions}")
  message(FATAL_ERROR
    "`VTK_LOGGING_TIME_PRECISION` must be one of "
    "${known_logging_precisions_list}; given '${VTK_LOGGING_TIME_PRECISION}'")
endif ()

#-----------------------------------------------------------------------------
# Add an option to enable/disable catalyst2 support.
option(VTK_ENABLE_CATALYST "Build catalyst-dependent modules, including the VTK catalyst implementation." OFF)
mark_as_advanced(VTK_ENABLE_CATALYST)

#-----------------------------------------------------------------------------
# Add an option to enable/disable SPDX generation
# Remove the "Experimental" once https://gitlab.kitware.com/vtk/vtk/-/issues/18999 is addressed
option(VTK_GENERATE_SPDX "Generate SPDX file for each module." OFF)
mark_as_advanced(VTK_GENERATE_SPDX)

include(vtkEncodeString)

# Set up our directory structure for output libraries and binaries
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${VTK_BINARY_DIR}/${CMAKE_INSTALL_BINDIR}")
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${VTK_BINARY_DIR}/${CMAKE_INSTALL_LIBDIR}")
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${VTK_BINARY_DIR}/${CMAKE_INSTALL_LIBDIR}")

set(vtk_requested_modules)
set(vtk_rejected_modules)
if (VTK_WRAP_PYTHON)
  list(APPEND vtk_requested_modules
    VTK::WrappingPythonCore)
  set("_vtk_module_reason_VTK::WrappingPythonCore"
    "via `VTK_WRAP_PYTHON`")
  if (NOT VTK_WHEEL_BUILD)
    list(APPEND vtk_requested_modules
      VTK::PythonInterpreter)
    set("_vtk_module_reason_VTK::PythonInterpreter"
      "via `VTK_WRAP_PYTHON AND NOT VTK_WHEEL_BUILD`")
  endif ()
else ()
  list(APPEND vtk_rejected_modules
    VTK::Python)
  set("_vtk_module_reason_VTK::Python"
    "via `VTK_WRAP_PYTHON`")
endif ()
if (VTK_WRAP_JAVA)
  list(APPEND vtk_requested_modules
    VTK::Java)
else ()
  list(APPEND vtk_rejected_modules
    VTK::Java)
endif ()
set("_vtk_module_reason_VTK::Java"
  "via `VTK_WRAP_JAVA`")
if (VTK_WRAP_SERIALIZATION)
  list(APPEND vtk_requested_modules
    VTK::SerializationManager)
  if (VTK_BUILD_TESTING)
    list(APPEND vtk_requested_modules
      VTK::TestingSerialization)
  endif ()
  set("_vtk_module_reason_VTK::TestingSerialization"
  "via `VTK_WRAP_SERIALIZATION` AND `VTK_BUILD_TESTING`")
  if (CMAKE_SYSTEM_NAME STREQUAL "Emscripten")
    list(APPEND vtk_requested_modules
      VTK::WebAssembly)
  else ()
    list(APPEND vtk_rejected_modules
      VTK::WebAssembly)
  endif ()
  set("_vtk_module_reason_VTK::WebAssembly"
  "via `VTK_WRAP_SERIALIZATION` AND `CMAKE_SYSTEM_NAME` STREQUAL Emscripten")
else ()
  list(APPEND vtk_rejected_modules
    VTK::SerializationManager
    VTK::TestingSerialization)
endif ()
set("_vtk_module_reason_VTK::SerializationManager"
  "via `VTK_WRAP_SERIALIZATION`")
# For vtkTkRenderWidget (only useful with Python, since WRAP_TCL is gone)
if (VTK_USE_TK)
  if (VTK_GROUP_ENABLE_Tk STREQUAL "DEFAULT")
    set(VTK_GROUP_ENABLE_Tk "WANT")
  elseif (VTK_GROUP_ENABLE_Tk STREQUAL "NO")
    message(FATAL_ERROR "VTK_USE_TK=ON is not compatible with VTK_GROUP_ENABLE_Tk=NO")
  endif ()
endif ()
if (VTK_USE_MPI)
  if (VTK_GROUP_ENABLE_MPI STREQUAL "DEFAULT")
    set(VTK_GROUP_ENABLE_MPI "WANT")
  elseif (VTK_GROUP_ENABLE_MPI STREQUAL "NO")

=== Examples/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12...3.16 FATAL_ERROR)
project(VTKExamples)

if (VTK_BINARY_DIR)
  function (add_example dir)
    if (vtk_cmake_build_dir)
      add_test(
        NAME    "VTKExample-${dir}"
        COMMAND "${CMAKE_COMMAND}"
                "-Dconfig=$<CONFIGURATION>"
                "-Dgenerator=${CMAKE_GENERATOR}"
                "-Dsource=${CMAKE_CURRENT_SOURCE_DIR}"
                "-Dbinary=${CMAKE_CURRENT_BINARY_DIR}"
                "-Dexample_dir=${dir}"
                "-Dbuild_type=${CMAKE_BUILD_TYPE}"
                "-Dshared=${BUILD_SHARED_LIBS}"
                "-Dvtk_dir=${vtk_cmake_build_dir}"
                "-Dctest=${CMAKE_CTEST_COMMAND}"
                "-Dplatform=${CMAKE_GENERATOR_PLATFORM}"
                "-Dtoolset=${CMAKE_GENERATOR_TOOLSET}"
                "-Dvtk_binary_dir=${CMAKE_RUNTIME_OUTPUT_DIRECTORY}"
                -P "${CMAKE_CURRENT_LIST_DIR}/RunExample.cmake")
      set_property(TEST "VTKExample-${dir}" APPEND
        PROPERTY
          SKIP_REGULAR_EXPRESSION "Skipping example")
    endif ()
  endfunction ()
else ()
  macro (add_example dir)
    add_subdirectory("${dir}")
  endmacro ()
endif ()

if (ANDROID)
  #add_example(Android)
elseif (APPLE_IOS)
  #add_example(iOS)
elseif (EMSCRIPTEN)
  if (CMAKE_VERSION VERSION_GREATER_EQUAL "3.13")
    add_example(Emscripten/Cxx/AsyncClipper)
    add_example(Emscripten/Cxx/Cone)
    add_example(Emscripten/Cxx/ConeFullScreen)
    add_example(Emscripten/Cxx/MultiCone)
    add_example(Emscripten/Cxx/WrappedAsyncClipper)
    add_example(Emscripten/Cxx/WrappedMace)
  endif ()
else ()
  add_example(AMR/Cxx)
  add_example(Annotation/Cxx/LabeledMesh)
  add_example(Build/vtkMy)
  add_example(Charts/Cxx)
  add_example(DataManipulation/Cxx)
  #add_example(GUI/Cocoa) # xcode project
  add_example(GUI/Qt/FourPaneViewer)
  add_example(GUI/Qt/ImageViewer)
  add_example(GUI/Qt/SimpleView)
  add_example(GUI/Qt/TouchGestureViewer)
  add_example(GUI/Qt/MinimalQtVTKApp)
  add_example(GUI/QML/QtQuickProperty)
  add_example(GUI/QML/QtQuickBoxWidget)
  add_example(GUI/QML/QtQuickChartsOn3DScene)
  add_example(GUI/QML/QtQuickCone)
  add_example(IO/Cxx)
  add_example(ImageProcessing/Cxx)
  add_example(Infovis/Cxx)
  add_example(Medical/Cxx)
  add_example(Modelling/Cxx)
  add_example(MultiBlock/Cxx)
  add_example(ParallelProcessing/Generic/Cxx)

  add_example(Modules/UsingVTK)
  add_example(Modules/Wrapping)
endif ()

=== Charts/Core/CMakeLists.txt ===
set(classes
  vtkAxis
  vtkAxisExtended
  vtkCategoryLegend
  vtkChart
  vtkChartBox
  vtkChartHistogram2D
  vtkChartLegend
  vtkChartMatrix
  vtkChartParallelCoordinates
  vtkChartPie
  vtkChartXY
  vtkChartXYZ
  vtkColorLegend
  vtkColorTransferControlPointsItem
  vtkColorTransferFunctionItem
  vtkCompositeControlPointsItem
  vtkCompositeTransferFunctionItem
  vtkContextArea
  vtkContextPolygon
  vtkControlPointsItem
  vtkInteractiveArea
  vtkLookupTableItem
  vtkPiecewiseControlPointsItem
  vtkPiecewiseFunctionItem
  vtkPiecewisePointHandleItem
  vtkPlot
  vtkPlot3D
  vtkPlotArea
  vtkPlotBag
  vtkPlotBar
  vtkPlotBarRangeHandlesItem
  vtkPlotBox
  vtkPlotFunctionalBag
  vtkPlotGrid
  vtkPlotHistogram2D
  vtkPlotLine
  vtkPlotLine3D
  vtkPlotParallelCoordinates # This adds a vtkInfovisCore dep for one class...
  vtkPlotPie
  vtkPlotPoints
  vtkPlotPoints3D
  vtkPlotRangeHandlesItem
  vtkPlotStacked
  vtkPlotSurface
  vtkRangeHandlesItem
  vtkScalarsToColorsItem
  vtkScatterPlotMatrix
  )

vtk_module_add_module(VTK::ChartsCore
  CLASSES ${classes})
vtk_add_test_mangling(VTK::ChartsCore)

=== Common/Archive/CMakeLists.txt ===
set(classes
  vtkBufferedArchiver
  vtkPartitionedArchiver)

vtk_module_find_package(PRIVATE_IF_SHARED
  PACKAGE LibArchive)

vtk_module_add_module(VTK::CommonArchive
  CLASSES ${classes})

vtk_module_link(VTK::CommonArchive NO_KIT_EXPORT_IF_SHARED PRIVATE LibArchive::LibArchive)
vtk_add_test_mangling(VTK::CommonArchive)

=== Common/Color/CMakeLists.txt ===
set(classes
  vtkColorSeries
  vtkNamedColors)

vtk_module_add_module(VTK::CommonColor
  CLASSES ${classes})
vtk_add_test_mangling(VTK::CommonColor)

=== Common/ComputationalGeometry/CMakeLists.txt ===
set(classes
  vtkBilinearQuadIntersection
  vtkCardinalSpline
  vtkKochanekSpline
  vtkParametricBohemianDome
  vtkParametricBour
  vtkParametricBoy
  vtkParametricCatalanMinimal
  vtkParametricConicSpiral
  vtkParametricCrossCap
  vtkParametricDini
  vtkParametricEllipsoid
  vtkParametricEnneper
  vtkParametricFigure8Klein
  vtkParametricFunction
  vtkParametricHenneberg
  vtkParametricKlein
  vtkParametricKuen
  vtkParametricMobius
  vtkParametricPluckerConoid
  vtkParametricPseudosphere
  vtkParametricRandomHills
  vtkParametricRoman
  vtkParametricSpline
  vtkParametricSuperEllipsoid
  vtkParametricSuperToroid
  vtkParametricTorus)

vtk_module_add_module(VTK::CommonComputationalGeometry
  CLASSES ${classes})
vtk_add_test_mangling(VTK::CommonComputationalGeometry)

=== Common/Core/CMakeLists.txt ===
include(CMakeDependentOption)
cmake_dependent_option(VTK_USE_64BIT_TIMESTAMPS "Build VTK with 64 bit timestamps" OFF
  "NOT CMAKE_SIZEOF_VOID_P GREATER 4" ON)
mark_as_advanced(VTK_USE_64BIT_TIMESTAMPS)

# Option to mangle VTK symbols
set(VTK_ABI_NAMESPACE_NAME
  "<DEFAULT>"
  CACHE STRING "Inline namespace name for mangling VTK symbols.")
mark_as_advanced(VTK_ABI_NAMESPACE_NAME)
set(VTK_ABI_NAMESPACE_ATTRIBUTES
  "<DEFAULT>"
  CACHE STRING "Inline namespace attributes for mangling VTK symbols.")
mark_as_advanced(VTK_ABI_NAMESPACE_ATTRIBUTES)

if (VTK_ABI_NAMESPACE_NAME STREQUAL "<DEFAULT>")
  # The default is to not have an ABI namespace.
  # This is consistent with the existing practice.
  set(VTK_ABI_NAMESPACE_NAME "")
endif ()
set_property(GLOBAL PROPERTY _vtk_abi_namespace_name "${VTK_ABI_NAMESPACE_NAME}")

if (VTK_ABI_NAMESPACE_ATTRIBUTES STREQUAL "<DEFAULT>")
  set(VTK_ABI_NAMESPACE_ATTRIBUTES "")
endif()
set_property(GLOBAL PROPERTY _vtk_abi_namespace_attributes "${VTK_ABI_NAMESPACE_ATTRIBUTES}")

if (VTK_ABI_NAMESPACE_NAME STREQUAL "")
  set(VTK_HAS_ABI_NAMESPACE OFF)
  set(VTK_ABI_NAMESPACE_BEGIN "")
  set(VTK_ABI_NAMESPACE_END "")
else ()
  message(STATUS "VTK ABI namespace: ${VTK_ABI_NAMESPACE_NAME}")
  set(_vtk_abi_namespace_name_regex "^[a-zA-Z0-9_]+$")
  if (NOT VTK_ABI_NAMESPACE_NAME MATCHES "${_vtk_abi_namespace_name_regex}")
    message(FATAL_ERROR
      "The configured VTK_ABI_NAMESPACE_NAME='${VTK_ABI_NAMESPACE_NAME}' is "
      "not supported, it must match the regular expression "
      "'${_vtk_abi_namespace_name_regex}'.  To add things like attributes, "
      "configure VTK with -DVTK_ABI_NAMESPACE_ATTRIBUTES='"
      "__attribute__((visibility(\"hidden\")))'.")
  endif()
  unset(_vtk_abi_namespace_name_regex)
  set(VTK_HAS_ABI_NAMESPACE ON)
  set(VTK_ABI_NAMESPACE_BEGIN "inline namespace ${VTK_ABI_NAMESPACE_ATTRIBUTES} ${VTK_ABI_NAMESPACE_NAME} {")
  set(VTK_ABI_NAMESPACE_END "}")
endif ()

if (VTK_ABI_NAMESPACE_ATTRIBUTES STREQUAL "")
  set(VTK_HAS_ABI_NAMESPACE_ATTRIBUTES OFF)
else ()
  set(VTK_HAS_ABI_NAMESPACE_ATTRIBUTES ON)
endif ()

configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/vtkABINamespace.h.in"
  "${CMAKE_CURRENT_BINARY_DIR}/vtkABINamespace.h"
  @ONLY)

if (CMAKE_SIZEOF_VOID_P GREATER 4)
 set(vtk_use_64bit_ids_default ON)
else ()
 set(vtk_use_64bit_ids_default OFF)
endif ()

option(VTK_USE_64BIT_IDS "Build VTK with 64 bit ids" "${vtk_use_64bit_ids_default}")
mark_as_advanced(VTK_USE_64BIT_IDS)

option(VTK_USE_FUTURE_CONST "Adds more const to APIs. Opt-in because it may break compatibility" OFF)
mark_as_advanced(VTK_USE_FUTURE_CONST)

option(VTK_USE_FUTURE_BOOL "Changes some ints to bools. Opt-in because it may break compatibility" OFF)
mark_as_advanced(VTK_USE_FUTURE_BOOL)

option(VTK_DEBUG_LEAKS "Build leak checking support into VTK." OFF)
mark_as_advanced(VTK_DEBUG_LEAKS)

# See vtkDataArrayRange.h docs for more info on these:
cmake_dependent_option(VTK_DEBUG_RANGE_ITERATORS
  "Detect usage errors with the for-range iterators (SLOW)." OFF
  "CMAKE_BUILD_TYPE STREQUAL \"Debug\"" OFF)
mark_as_advanced(VTK_DEBUG_RANGE_ITERATORS)
cmake_dependent_option(VTK_ALWAYS_OPTIMIZE_ARRAY_ITERATORS
  "Enable additional optimizations for array iterators in Debug builds." OFF
  "NOT VTK_DEBUG_RANGE_ITERATORS" OFF)
mark_as_advanced(VTK_ALWAYS_OPTIMIZE_ARRAY_ITERATORS)

# This option determines the behavior of the New methods of vtkObject derived
# classes. If this option is off then only classes specifically using the
# vtkObjectFactoryNewMacro and vtkAbstractObjectFactoryNewMacro will allow for
# overrides. If the method is on then vtkStandardNewMacro will use the
# vtkObjectFactoryNewMacro's implementation body.
option(VTK_ALL_NEW_OBJECT_FACTORY
  "Build all vtkObject derived classes with object factory new methods." OFF)
mark_as_advanced(VTK_ALL_NEW_OBJECT_FACTORY)

set(vtk_smp_sources)
set(vtk_smp_headers)
set(vtk_smp_nowrap_headers)
set(vtk_smp_templates)
set(vtk_smp_defines)
set(vtk_smp_libraries)
set(vtk_smp_enable_sequential 0)
set(vtk_smp_enable_stdthread 0)
set(vtk_smp_enable_tbb 0)
set(vtk_smp_enable_openmp 0)
set(VTK_SMP_IMPLEMENTATION_TYPE)
include("${CMAKE_CURRENT_SOURCE_DIR}/vtkSMPSelection.cmake")

set(vtk_object_base_defines)

# An optional dependency on memkind
set(vtk_memkind_libraries)
if (VTK_USE_MEMKIND)
  vtk_module_find_package(
    PACKAGE MEMKIND)
  list(APPEND vtk_memkind_libraries
    MEMKIND::MEMKIND)
  # XXX(memkind-1.10): Once 1.10 is required, this is always true.
  file(READ "${MEMKIND_INCLUDE_DIR}/memkind.h" memkind_h_contents)
  set(memkind_has_dax_kmem 0)
  # Look for the symbol in the header.
  if (memkind_h_contents MATCHES " MEMKIND_DAX_KMEM[ ;\n]")
    set(memkind_has_dax_kmem 1)
  endif ()
  list(APPEND vtk_object_base_defines "VTK_MEMKIND_HAS_DAX_KMEM=$<BOOL:${memkind_has_dax_kmem}>")
endif ()

# Generate the vtkTypeList_Create macros:
include("${CMAKE_CURRENT_SOURCE_DIR}/vtkCreateTypeListMacros.cmake")
CreateTypeListMacros(
  VTK_TYPELISTMACRO_HEADER_CONTENTS
  99
  vtkTypeList_Create
  "vtkTypeList::TypeList"
  "vtkTypeList::NullType")
configure_file(vtkTypeListMacros.h.in vtkTypeListMacros.h)

# And the ArrayDispatch array list header:
option(VTK_DISPATCH_AOS_ARRAYS "Include array-of-structs vtkDataArray subclasses in dispatcher." ON)
option(VTK_DISPATCH_SOA_ARRAYS "Include struct-of-arrays vtkDataArray subclasses in dispatcher." OFF)
option(VTK_DISPATCH_TYPED_ARRAYS "Include vtkTypedDataArray subclasses (e.g. old mapped arrays) in dispatcher." OFF) # VTK_DEPRECATED_IN_9_5_0

option(VTK_DISPATCH_AFFINE_ARRAYS "Include implicit vtkDataArray subclasses based on an affine function backend in dispatcher" OFF)
option(VTK_DISPATCH_CONSTANT_ARRAYS "Include implicit vtkDataArray subclasses based on a constant backend in dispatcher" OFF)
option(VTK_DISPATCH_STD_FUNCTION_ARRAYS "Include implicit vtkDataArray subclasses based on std::function in dispatcher" OFF)
option(VTK_DISPATCH_STRUCTURED_POINT_ARRAYS "Include implicit vtkDataArray subclasses based on structured point backend dispatcher" ON)

option(VTK_WARN_ON_DISPATCH_FAILURE "If enabled, vtkArrayDispatch will print a warning when a dispatch fails." OFF)

mark_as_advanced(
  VTK_DISPATCH_AOS_ARRAYS
  VTK_DISPATCH_SOA_ARRAYS
  VTK_DISPATCH_TYPED_ARRAYS # VTK_DEPRECATED_IN_9_5_0

  VTK_DISPATCH_AFFINE_ARRAYS
  VTK_DISPATCH_CONSTANT_ARRAYS
  VTK_DISPATCH_STD_FUNCTION_ARRAYS
  VTK_DISPATCH_STRUCTURED_POINT_ARRAYS

  VTK_WARN_ON_DISPATCH_FAILURE)

option(VTK_BUILD_SCALED_SOA_ARRAYS "Include struct-of-arrays with scaled vtkDataArray implementation." OFF)

configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/vtkVTK_DISPATCH_IMPLICIT_ARRAYS.h.in"
  "${CMAKE_CURRENT_BINARY_DIR}/vtkVTK_DISPATCH_IMPLICIT_ARRAYS.h"
  @ONLY)

include("${CMAKE_CURRENT_SOURCE_DIR}/vtkCreateArrayDispatchArrayList.cmake")
vtkArrayDispatch_default_array_setup()
vtkArrayDispatch_generate_array_header(VTK_ARRAYDISPATCH_ARRAY_LIST)
configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/vtkArrayDispatchArrayList.h.in"
  "${CMAKE_CURRENT_BINARY_DIR}/vtkArrayDispatchArrayList.h"
  @ONLY)

# create a list of source files for explicit array type instantiations
set(instantiation_sources)

include(vtkTypeLists)

foreach (INSTANTIATION_VALUE_TYPE IN LISTS vtk_numeric_types)
  # only instantiate fundamental types, not typedefs
  if (INSTANTIATION_VALUE_TYPE STREQUAL "vtkIdType")
    continue()
  endif ()
  # create a file suffix from the type
  string(REPLACE " " "_" _suffix "${INSTANTIATION_VALUE_TYPE}")

  set(_list
    vtkAffineArrayInstantiate
    vtkAffineImplicitBackendInstantiate
    vtkCompositeArrayInstantiate
    vtkCompositeImplicitBackendInstantiate
    vtkConstantArrayInstantiate
    vtkConstantImplicitBackendInstantiate
    vtkIndexedArrayInstantiate
    vtkIndexedImplicitBackendInstantiate
    vtkSOADataArrayTemplateInstantiate
    vtkStdFunctionArrayInstantiate
    vtkStructuredPointBackendInstantiate
    vtkStructuredPointArrayInstantiate
    vtkTypedDataArrayInstantiate)
  if (VTK_BUILD_SCALED_SOA_ARRAYS)
    list(APPEND _list "vtkScaledSOADataArrayTemplateInstantiate")
  endif ()

  # see comments in vtkGenericDataArray.h for explanation
  if (INSTANTIATION_VALUE_TYPE MATCHES "(^| )long( |$)")
    list(APPEND _list "vtkGenericDataArrayValueRangeInstantiate")
  endif ()

  # generate cxx file to instantiate template with this type
  foreach (_prefix IN LISTS _list)
    configure_file(
      "${CMAKE_CURRENT_SOURCE_DIR}/${_prefix}.cxx.in"
      "${CMAKE_CURRENT_BINARY_DIR}/${_prefix}_${_suffix}.cxx"
      @ONLY)
    list(APPEND instantiation_sources
      "${CMAKE_CURRENT_BINARY_DIR}/${_prefix}_${_suffix}.cxx")
  endforeach ()
endforeach ()

set(classes
  vtkAbstractArray
  vtkAnimationCue
  vtkArchiver
  vtkArray
  vtkArrayCoordinates
  vtkArrayExtents
  vtkArrayExtentsList
  vtkArrayIterator
  vtkArrayRange
  vtkArraySort
  vtkArrayWeights
  vtkAtomicMutex
  vtkBitArray
  vtkBitArrayIterator
  vtkBoxMuellerRandomSequence
  vtkBreakPoint
  vtkByteSwap
  vtkCallbackCommand
  vtkCharArray
  vtkCollection
  vtkCollectionIterator
  vtkCommand
  vtkCommonInformationKeyManager
  vtkDataArray
  vtkDataArrayCollection
  vtkDataArrayCollectionIterator
  vtkDataArraySelection
  vtkDebugLeaks
  vtkDebugLeaksManager
  vtkDeserializer
  vtkDoubleArray
  vtkDynamicLoader
  vtkEventForwarderCommand
  vtkFileOutputWindow
  vtkFloatArray
  vtkFloatingPointExceptions
  vtkGarbageCollector
  vtkGarbageCollectorManager
  vtkGaussianRandomSequence
  vtkIdList
  vtkIdListCollection
  vtkIdTypeArray
  vtkIndent
  vtkInformation
  vtkInformationDataObjectKey
  vtkInformationDoubleKey
  vtkInformationDoubleVectorKey
  vtkInformationIdTypeKey
  vtkInformationInformationKey
  vtkInformationInformationVectorKey
  vtkInformationIntegerKey
  vtkInformationIntegerPointerKey
  vtkInformationIntegerVectorKey
  vtkInformationIterator
  vtkInformationKey
  vtkInformationKeyLookup
  vtkInformationKeyVectorKey
  vtkInformationObjectBaseKey
  vtkInformationObjectBaseVectorKey
  vtkInformationRequestKey
  vtkInformationStringKey
  vtkInformationStringVectorKey
  vtkInformationUnsignedLongKey
  vtkInformationVariantKey
  vtkInformationVariantVectorKey
  vtkInformationVector
  vtkIntArray
  vtkInvoker
  vtkLargeInteger
  vtkLogger
  vtkLongArray
  vtkLongLongArray
  vtkLookupTable
  vtkMath
  vtkMarshalContext
  vtkMersenneTwister
  vtkMinimalStandardRandomSequence
  vtkMultiThreader
  vtkNumberToString
  vtkOStrStreamWrapper
  vtkOStreamWrapper
  vtkObject
  vtkObjectBase
  vtkObjectFactory
  vtkObjectFactoryCollection
  vtkOldStyleCallbackCommand
  vtkOutputWindow
  vtkOverrideInformation
  vtkOverrideInformationCollection
  vtkPoints
  vtkPoints2D
  vtkPriorityQueue
  vtkRandomPool
  vtkRandomSequence
  vtkReferenceCount
  vtkSerializer
  vtkScalarsToColors
  vtkShortArray
  vtkSignedCharArray
  vtkSmartPointerBase
  vtkSortDataArray
  vtkStdString
  vtkStringArray
  vtkStringOutputWindow
  vtkStringToken
  vtkTimePointUtility
  vtkTimeStamp
  vtkThreadedCallbackQueue
  vtkUnsignedCharArray
  vtkUnsignedIntArray
  vtkUnsignedLongArray
  vtkUnsignedLongLongArray
  vtkUnsignedShortArray
  vtkVariant
  vtkVariantArray
  vtkVersion
  vtkVoidArray
  vtkWeakPointerBase
  vtkWeakReference
  vtkWindow
  vtkXMLFileOutputWindow)

set(template_classes
  vtkAOSDataArrayTemplate
  vtkArrayDispatch
  vtkArrayInterpolate
  vtkArrayIteratorTemplate
  vtkArrayPrint
  vtkDenseArray
  vtkGenericDataArray
  vtkMappedDataArray
  vtkSOADataArrayTemplate
  vtkSparseArray
  vtkThreadedTaskQueue
  vtkTypedArray
  vtkTypedDataArray)

set(nowrap_template_classes
  vtkCompositeImplicitBackend
  vtkImplicitArray
  vtkIndexedImplicitBackend
  vtkStructuredPointBackend
  vtkTypeList)

# Hand written (de)serialization routines
set(serialization_helper_sources)
set(serialization_helper_headers)
if (VTK_WRAP_SERIALIZATION)
  list(APPEND serialization_helper_sources
    vtkDataArraySerDesHelper.cxx
    vtkInformationSerDesHelper.cxx
    vtkScalarsToColorsSerDesHelper.cxx

=== Common/DataModel/CMakeLists.txt ===
set(classes
  vtkAMRBox
  vtkAMRUtilities
  vtkAbstractCellArray
  vtkAbstractCellLinks
  vtkAbstractCellLocator
  vtkAbstractElectronicData
  vtkAbstractPointLocator
  vtkAdjacentVertexIterator
  vtkAnimationScene
  vtkAnnotation
  vtkAnnotationLayers
  vtkAnnulus
  vtkArrayData
  vtkAtom
  vtkAttributesErrorMetric
  vtkBSPCuts
  vtkBSPIntersections
  vtkBezierCurve
  vtkBezierHexahedron
  vtkBezierInterpolation
  vtkBezierQuadrilateral
  vtkBezierTetra
  vtkBezierTriangle
  vtkBezierWedge
  vtkBiQuadraticQuad
  vtkBiQuadraticQuadraticHexahedron
  vtkBiQuadraticQuadraticWedge
  vtkBiQuadraticTriangle
  vtkBond
  vtkBoundingBox
  vtkBox
  vtkCell
  vtkCell3D
  vtkCellArray
  vtkCellArrayIterator
  vtkCellAttribute
  vtkCellAttributeCalculator
  vtkCellData
  vtkCellGrid
  vtkCellGridBoundsQuery
  vtkCellGridCopyQuery
  vtkCellGridEvaluator
  vtkCellGridRangeQuery
  vtkCellGridQuery
  vtkCellGridResponders
  vtkCellGridSidesCache
  vtkCellGridSidesQuery
  vtkCellIterator
  vtkCellLinks
  vtkCellLocator
  vtkCellLocatorStrategy
  vtkCellMetadata
  vtkCellTreeLocator
  vtkCellTypes
  vtkClosestNPointsStrategy
  vtkClosestPointStrategy
  vtkCompositeDataIterator
  vtkCompositeDataSet
  vtkCone
  vtkConvexPointSet
  vtkCoordinateFrame
  vtkCubicLine
  vtkCylinder
  vtkDataAssembly
  vtkDataAssemblyUtilities
  vtkDataObject
  vtkDataObjectCollection
  vtkDataObjectTree
  vtkDataObjectTreeIterator
  vtkDataObjectTypes
  vtkDataSet
  vtkDataSetAttributes
  vtkDataSetAttributesFieldList
  vtkDataSetCellIterator
  vtkDataSetCollection
  vtkDirectedAcyclicGraph
  vtkDirectedGraph
  vtkDistributedGraphHelper
  vtkEdgeListIterator
  vtkEdgeTable
  vtkEmptyCell
  vtkExplicitStructuredGrid
  vtkExtractStructuredGridHelper
  vtkFieldData
  vtkFindCellStrategy
  vtkFrustum
  vtkGenericAdaptorCell
  vtkGenericAttribute
  vtkGenericAttributeCollection
  vtkGenericCell
  vtkGenericCellIterator
  vtkGenericCellTessellator
  vtkGenericDataSet
  vtkGenericEdgeTable
  vtkGenericInterpolatedVelocityField
  vtkGenericPointIterator
  vtkGenericSubdivisionErrorMetric
  vtkGeometricErrorMetric
  vtkGraph
  vtkGraphEdge
  vtkGraphInternals
  vtkHexagonalPrism
  vtkHexahedron
  vtkHierarchicalBoxDataSet
  vtkHigherOrderCurve
  vtkHigherOrderHexahedron
  vtkHigherOrderInterpolation
  vtkHigherOrderQuadrilateral
  vtkHigherOrderTetra
  vtkHigherOrderTriangle
  vtkHigherOrderWedge
  vtkHyperTree
  vtkHyperTreeGrid
  vtkHyperTreeGridLocator
  vtkHyperTreeGridGeometricLocator
  vtkHyperTreeGridNonOrientedCursor
  vtkHyperTreeGridNonOrientedGeometryCursor
  vtkHyperTreeGridNonOrientedUnlimitedGeometryCursor
  vtkHyperTreeGridNonOrientedMooreSuperCursor
  vtkHyperTreeGridNonOrientedMooreSuperCursorLight
  vtkHyperTreeGridNonOrientedUnlimitedMooreSuperCursor
  vtkHyperTreeGridNonOrientedSuperCursor
  vtkHyperTreeGridNonOrientedSuperCursorLight
  vtkHyperTreeGridNonOrientedUnlimitedSuperCursor
  vtkHyperTreeGridNonOrientedVonNeumannSuperCursor
  vtkHyperTreeGridNonOrientedVonNeumannSuperCursorLight
  vtkHyperTreeGridOrientedCursor
  vtkHyperTreeGridOrientedGeometryCursor
  vtkImageData
  vtkImageIterator
  vtkImageTransform
  vtkImplicitBoolean
  vtkImplicitDataSet
  vtkImplicitFunction
  vtkImplicitFunctionCollection
  vtkImplicitHalo
  vtkImplicitSelectionLoop
  vtkImplicitSum
  vtkImplicitVolume
  vtkImplicitWindowFunction
  vtkInEdgeIterator
  vtkIncrementalOctreeNode
  vtkIncrementalOctreePointLocator
  vtkIncrementalPointLocator
  vtkInformationQuadratureSchemeDefinitionVectorKey
  vtkIterativeClosestPointTransform
  vtkKdNode
  vtkKdTree
  vtkKdTreePointLocator
  vtkLagrangeCurve
  vtkLagrangeHexahedron
  vtkLagrangeInterpolation
  vtkLagrangeQuadrilateral
  vtkLagrangeTetra
  vtkLagrangeTriangle
  vtkLagrangeWedge
  vtkLine
  vtkLocator
  vtkMarchingCubesTriangleCases
  vtkMarchingCubesPolygonCases
  vtkMarchingSquaresLineCases
  vtkMeanValueCoordinatesInterpolator
  vtkMergePoints
  vtkMolecule
  vtkMultiBlockDataSet
  vtkMultiPieceDataSet
  vtkMutableDirectedGraph
  vtkMutableUndirectedGraph
  vtkNonLinearCell
  vtkNonMergingPointLocator
  vtkOctreePointLocator
  vtkOctreePointLocatorNode
  vtkOrderedTriangulator
  vtkOutEdgeIterator
  vtkPartitionedDataSet
  vtkPartitionedDataSetCollection
  vtkPath
  vtkPentagonalPrism
  vtkPerlinNoise
  vtkPiecewiseFunction
  vtkPixel
  vtkPixelExtent
  vtkPixelTransfer
  vtkPlane
  vtkPlaneCollection
  vtkPlanes
  vtkPlanesIntersection
  vtkPointData
  vtkPointLocator
  vtkPointSet
  vtkPointSetCellIterator
  vtkPointsProjectedHull
  vtkPolyData
  vtkPolyDataCollection
  vtkPolyLine
  vtkPolyPlane
  vtkPolyVertex
  vtkPolygon
  vtkPolyhedron
  vtkPolyhedronUtilities
  vtkPyramid
  vtkQuad
  vtkQuadraticEdge
  vtkQuadraticHexahedron
  vtkQuadraticLinearQuad
  vtkQuadraticLinearWedge
  vtkQuadraticPolygon
  vtkQuadraticPyramid
  vtkQuadraticQuad
  vtkQuadraticTetra
  vtkQuadraticTriangle
  vtkQuadraticWedge
  vtkQuadratureSchemeDefinition
  vtkQuadric
  vtkRectilinearGrid
  vtkReebGraph
  vtkReebGraphSimplificationMetric
  vtkSelection
  vtkSelectionNode
  vtkSimpleCellTessellator
  vtkSmoothErrorMetric
  vtkSortFieldData
  vtkSphere
  vtkSpheres
  vtkSphericalPointIterator
  vtkSpline
  vtkStaticCellLinks
  vtkStaticCellLocator
  vtkStaticPointLocator
  vtkStaticPointLocator2D
  vtkStructuredCellArray
  vtkStructuredData
  vtkStructuredExtent
  vtkStructuredGrid
  vtkStructuredPoints
  vtkStructuredPointsCollection
  vtkSuperquadric
  vtkTable
  vtkTetra
  vtkTree
  vtkTreeBFSIterator
  vtkTreeDFSIterator
  vtkTreeIterator
  vtkTriQuadraticHexahedron
  vtkTriQuadraticPyramid
  vtkTriangle
  vtkTriangleStrip
  vtkUndirectedGraph
  vtkUniformGrid
  vtkUniformHyperTreeGrid
  vtkUnstructuredGrid
  vtkUnstructuredGridBase
  vtkUnstructuredGridCellIterator
  vtkVertex
  vtkVertexListIterator
  vtkVoxel
  vtkWedge
  vtkXMLDataElement

  # New classes for AMR
  vtkAMRDataInternals
  vtkAMRInformation
  vtkNonOverlappingAMR
  vtkOverlappingAMR
  vtkUniformGridAMR
  vtkUniformGridAMRDataIterator)

set(template_classes
  vtkAngularPeriodicDataArray
  vtkArrayListTemplate
  vtkMappedUnstructuredGrid
  vtkMappedUnstructuredGridCellIterator
  vtkPeriodicDataArray
  vtkStaticCellLinksTemplate
  vtkStaticEdgeLocatorTemplate
  vtkStaticFaceHashLinksTemplate)

set(nowrap_classes
  vtkHyperTreeGridEntry
  vtkHyperTreeGridGeometryEntry
  vtkHyperTreeGridGeometryUnlimitedEntry
  vtkHyperTreeGridGeometryLevelEntry
  vtkHyperTreeGridGeometryUnlimitedLevelEntry
  vtkHyperTreeGridLevelEntry)

set(headers
  vtkCellGridResponder.h
  vtkCellGridResponderBase.h
  vtkCellType.h
  vtkColor.h
  vtkDataAssemblyVisitor.h
  vtkDataObjectTreeInternals.h
  vtkHyperTreeGridScales.h
  vtkHyperTreeGridTools.h
  vtkIntersectionCounter.h
  vtkLabelMapLookup.h
  vtkRect.h
  vtkVector.h
  vtkVectorOperators.h)

set(nowrap_headers
  vtkCompositeDataSetNodeReference.h
  vtkCompositeDataSetRange.h
  vtkDataObjectImplicitBackendInterface.h
  vtkDataObjectTreeRange.h
  vtkPolyDataInternals.h)

set(templates
  vtkCompositeDataSet.txx)

set(private_templates
  vtkDataObjectImplicitBackendInterface.txx
  vtkImageIterator.txx)

include(vtkTypeLists)

set(instantiation_sources)
foreach (INSTANTIATION_VALUE_TYPE IN LISTS vtk_numeric_types)
  # only instantiate fundamental types, not typedefs
  if (INSTANTIATION_VALUE_TYPE STREQUAL "vtkIdType")
    continue()
  endif ()
  vtk_type_to_camel_case("${INSTANTIATION_VALUE_TYPE}" _cased_type)
  configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/vtkDataObjectImplicitBackendInstantiate.cxx.in"
    "${CMAKE_CURRENT_BINARY_DIR}/vtkDataObjectImplicitBackendInstantiate${_cased_type}.cxx")

    list(APPEND instantiation_sources
      "${CMAKE_CURRENT_BINARY_DIR}/vtkDataObjectImplicitBackendInstantiate${_cased_type}.cxx")
endforeach()

# Hand written (de)serialization routines
set(serialization_helper_sources)

if (VTK_WRAP_SERIALIZATION)
  list(APPEND serialization_helper_sources
    vtkCellArraySerDesHelper.cxx
    vtkDataSetAttributesSerDesHelper.cxx
    vtkFieldDataSerDesHelper.cxx
    vtkMultiBlockDataSetSerDesHelper.cxx
    vtkPartitionedDataSetSerDesHelper.cxx
    vtkPartitionedDataSetCollectionSerDesHelper.cxx
    vtkPiecewiseFunctionSerDesHelper.cxx
    vtkTableSerDesHelper.cxx
    vtkUnstructuredGridSerDesHelper.cxx)
endif ()

set(sources
  ${serialization_helper_sources}
  ${instantiation_sources})

vtk_module_add_module(VTK::CommonDataModel
  CLASSES           ${classes}
  NOWRAP_CLASSES    ${nowrap_classes}
  TEMPLATES         ${templates}
  TEMPLATE_CLASSES  ${template_classes}
  HEADERS           ${headers}
  SOURCES           ${sources}
  NOWRAP_HEADERS    ${nowrap_headers}
  PRIVATE_TEMPLATES ${private_templates})
vtk_add_test_mangling(VTK::CommonDataModel)

=== Common/ExecutionModel/CMakeLists.txt ===
set(classes
  vtkAggregateToPartitionedDataSetCollection
  vtkAlgorithm
  vtkAlgorithmOutput
  vtkAnnotationLayersAlgorithm
  vtkArrayDataAlgorithm
  vtkCachedStreamingDemandDrivenPipeline
  vtkCastToConcrete
  vtkCellGridAlgorithm
  vtkCompositeDataPipeline
  vtkCompositeDataSetAlgorithm
  vtkDataObjectAlgorithm
  vtkDataSetAlgorithm
  vtkDemandDrivenPipeline
  vtkDirectedGraphAlgorithm
  vtkEndFor
  vtkEnsembleSource
  vtkExecutionAggregator
  vtkExecutionRange
  vtkExecutive
  vtkExplicitStructuredGridAlgorithm
  vtkExtentRCBPartitioner
  vtkExtentSplitter
  vtkExtentTranslator
  vtkFilteringInformationKeyManager
  vtkForEach
  vtkGraphAlgorithm
  vtkHierarchicalBoxDataSetAlgorithm
  vtkHyperTreeGridAlgorithm
  vtkImageAlgorithm
  vtkImageInPlaceFilter
  vtkImageProgressIterator
  vtkImageToStructuredGrid
  vtkImageToStructuredPoints
  vtkInformationDataObjectMetaDataKey
  vtkInformationExecutivePortKey
  vtkInformationExecutivePortVectorKey
  vtkInformationIntegerRequestKey
  vtkMoleculeAlgorithm
  vtkMultiBlockDataSetAlgorithm
  vtkMultiTimeStepAlgorithm
  vtkParallelReader
  vtkPartitionedDataSetAlgorithm
  vtkPartitionedDataSetCollectionAlgorithm
  vtkPassInputTypeAlgorithm
  vtkPiecewiseFunctionAlgorithm
  vtkPiecewiseFunctionShiftScale
  vtkPointSetAlgorithm
  vtkPolyDataAlgorithm
  vtkProgressObserver
  vtkReaderAlgorithm
  vtkRectilinearGridAlgorithm
  vtkSMPProgressObserver
  vtkScalarTree
  vtkSelectionAlgorithm
  vtkSimpleImageToImageFilter
  vtkSimpleReader
  vtkSimpleScalarTree
  vtkSpanSpace
  vtkSphereTree
  vtkStreamingDemandDrivenPipeline
  vtkStructuredGridAlgorithm
  vtkTableAlgorithm
  vtkThreadedCompositeDataPipeline
  vtkThreadedImageAlgorithm
  vtkTimeRange
  vtkTreeAlgorithm
  vtkTrivialConsumer
  vtkTrivialProducer
  vtkUndirectedGraphAlgorithm
  vtkUniformGridPartitioner
  vtkUnstructuredGridAlgorithm
  vtkUnstructuredGridBaseAlgorithm

  # New AMR classes
  vtkNonOverlappingAMRAlgorithm
  vtkOverlappingAMRAlgorithm
  vtkUniformGridAMRAlgorithm)

set (template_classes
  vtkTemporalAlgorithm)

# Hand written (de)serialization routines
set(serialization_helper_sources)
if (VTK_WRAP_SERIALIZATION)
  list(APPEND serialization_helper_sources
    vtkAlgorithmSerDesHelper.cxx)
endif ()

vtk_module_add_module(VTK::CommonExecutionModel
  CLASSES ${classes}
  SOURCES ${serialization_helper_sources}
  TEMPLATE_CLASSES ${template_classes})
vtk_add_test_mangling(VTK::CommonExecutionModel)

=== Common/Misc/CMakeLists.txt ===
set(classes
  vtkContourValues
  vtkErrorCode
  vtkExprTkFunctionParser
  vtkFunctionParser
  vtkHeap
  vtkPolygonBuilder
  vtkResourceFileLocator)

# ExprTk uses lots of templates and exceeds object file limits
if (MINGW AND NOT ANDROID) # MINGW is set when cross-compiling for ANDROID, see issue https://gitlab.kitware.com/cmake/cmake/-/issues/22647
  set_property(SOURCE vtkExprTkFunctionParser.cxx APPEND
    PROPERTY
      COMPILE_FLAGS "-Wa,-mbig-obj")
endif ()

# ExprTk internally relies on exceptions. This compile flag enables exception support in emscripten compiler.
if (CMAKE_SYSTEM_NAME STREQUAL "Emscripten")
  set_property(SOURCE vtkExprTkFunctionParser.cxx APPEND
    PROPERTY
      COMPILE_FLAGS "-fexceptions")
endif ()

vtk_module_add_module(VTK::CommonMisc
  CLASSES ${classes})

# The final executable linking to CommonMisc must use -sDISABLE_EXCEPTION_CATCHING=0 and -fexceptions as well.
if (CMAKE_SYSTEM_NAME STREQUAL "Emscripten")
  vtk_module_link_options(VTK::CommonMisc
    INTERFACE
      "-sDISABLE_EXCEPTION_CATCHING=0"
      "-fexceptions")
endif ()
vtk_add_test_mangling(VTK::CommonMisc)

=== Common/System/CMakeLists.txt ===
vtk_module_find_package(PRIVATE_IF_SHARED
  PACKAGE Threads)

set(classes
  vtkClientSocket
  vtkDirectory
  vtkExecutableRunner
  vtkServerSocket
  vtkSocket
  vtkSocketCollection
  vtkTimerLog)

include("${CMAKE_CURRENT_SOURCE_DIR}/vtkTestSocketFeatures.cmake")

set(vtkSocket_defines)
if (VTK_HAVE_GETSOCKNAME_WITH_SOCKLEN_T)
  list(APPEND vtkSocket_defines "VTK_HAVE_GETSOCKNAME_WITH_SOCKLEN_T")
endif ()
if (VTK_HAVE_SO_REUSEADDR)
  list(APPEND vtkSocket_defines "VTK_HAVE_SO_REUSEADDR")
endif ()
if(VTK_NO_PLATFORM_SOCKETS)
  list(APPEND vtkSocket_defines "VTK_SOCKET_FAKE_API")
endif()

set_source_files_properties(vtkSocket.cxx
  PROPERTIES
    COMPILE_DEFINITIONS "${vtkSocket_defines}")

vtk_module_add_module(VTK::CommonSystem
  CLASSES ${classes})
vtk_module_link(VTK::CommonSystem
  NO_KIT_EXPORT_IF_SHARED
  PRIVATE
    $<$<PLATFORM_ID:WIN32>:wsock32>
    Threads::Threads)
vtk_add_test_mangling(VTK::CommonSystem)

=== Common/Transforms/CMakeLists.txt ===
set(classes
  vtkAbstractTransform
  vtkCylindricalTransform
  vtkGeneralTransform
  vtkHomogeneousTransform
  vtkIdentityTransform
  vtkLandmarkTransform
  vtkLinearTransform
  vtkMatrixToHomogeneousTransform
  vtkMatrixToLinearTransform
  vtkPerspectiveTransform
  vtkSphericalTransform
  vtkThinPlateSplineTransform
  vtkTransform
  vtkTransform2D
  vtkTransformCollection
  vtkWarpTransform)

vtk_module_add_module(VTK::CommonTransforms
  CLASSES ${classes})
vtk_add_test_mangling(VTK::CommonTransforms)

=== debian/control ===
Source: vtk9
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Anton Gladky <gladk@debian.org>,
           Gert Wollny <gewo@debian.org>,
           Nico Schlömer <nico.schloemer@gmail.com>
Section: graphics
Priority: optional
Build-Depends: dpkg-dev (>= 1.22.5),
               chrpath,
               cmake,
               debhelper-compat (= 13),
               default-jdk [!hppa !hurd-any !s390x],
               openjdk-17-jdk [s390x],
               default-libmysqlclient-dev,
               dh-sequence-python3,
               doxygen-latex,
               ghostscript,
               gnuplot-nox,
               graphviz,
               hdf5-tools,
               dh-sequence-javahelper,
               libalglib-dev,
               javahelper,
               libavcodec-dev,
               libavformat-dev,
               libavutil-dev,
               libdigest-md5-perl,
               libdouble-conversion-dev,
               libeigen3-dev,
               libexpat-dev,
               libfontconfig-dev,
               libfreetype-dev,
               libgdal-dev,
               libgl-dev,
               libgl2ps-dev,
               libglew-dev,
               libglu-dev,
               libhdf5-mpi-dev,
               libhpdf-dev,
               libjpeg-dev,
               libjs-mathjax,
               libjsoncpp-dev,
               liblz4-dev,
               libnetcdf-dev (>= 1:4.9.0),
               libogg-dev,
               libpng-dev,
               libpq-dev,
               libproj-dev,
               libsqlite3-dev,
               libswscale-dev,
               libtbb-dev [linux-any],
               libtheora-dev,
               libtiff-dev,
               libutfcpp-dev,
               libx11-dev,
               libxdmf-dev,
               libxml2-dev,
               libxpm-dev,
               libxt-dev,
               lzma,
               nlohmann-json3-dev,
               mpi-default-dev,
               pkgconf,
               python3-dev,
               python3-matplotlib,
               python3-mpi4py,
               qt6-base-dev,
               texlive-binaries,
               x11proto-core-dev,
               xauth,
               xvfb,
               zlib1g-dev,
               sqlite3
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/science-team/vtk9
Vcs-Git: https://salsa.debian.org/science-team/vtk9.git
Homepage: https://www.vtk.org/
Rules-Requires-Root: no

Package: libvtk9-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends},
         ${shlibs:Depends},
         default-jdk [!hppa !hurd-any !s390x],
         openjdk-17-jdk [s390x],
         default-libmysqlclient-dev,
         libavcodec-dev,
         libavformat-dev,
         libavutil-dev,
         libc6-dev,
         libdouble-conversion-dev,
         libeigen3-dev,
         libexpat-dev,
         libfreetype-dev,
         libgdal-dev,
         libgl-dev,
         libgl2ps-dev,
         libgl1-mesa-dev | libgl-dev,
         libglew-dev,
         libglu1-mesa-dev | libglu-dev,
         libhdf5-mpi-dev,
         libjpeg-dev,
         libjsoncpp-dev,
         liblz4-dev,
         libnetcdf-dev,
         libpng-dev,
         libpq-dev,
         libproj-dev,
         libpython3-dev,
         libswscale-dev,
         libtbb-dev [linux-any],
         libtheora-dev,
         libtiff-dev,
         libutfcpp-dev,
         libvtk9.5 (= ${binary:Version}),
         libvtk9-java (= ${binary:Version}) [!hppa !hurd-any],
         libx11-dev,
         libxft-dev,
         libxml2-dev,
         libxss-dev,
         libxt-dev,
         nlohmann-json3-dev,
         mpi-default-dev,
         python3-vtk9 (= ${binary:Version}),
         vtk9 (= ${binary:Version}),
         x11proto-core-dev,
         zlib1g-dev
Suggests: vtk9-doc,
          vtk9-examples
Description: VTK header files
 The Visualization Toolkit (VTK) is an open-source software system
 for 3D computer graphics, image processing, and visualization.
 .
 This package provides the VTK header files required to compile
 C++ programs that use VTK to do 3D visualisation.

Package: libvtk9.5
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Suggests: mpi-default-bin,
          vtk9-doc,
          vtk9-examples
Breaks: libvtk9.1 (<< ${source:Version}),
        libvtk9 (<< 9.1.0+really9.1.0)
Provides: ${t64:Provides}
Replaces: libvtk9.1,
          libvtk9 (<< 9.1.0+really9.1.0)
Description: VTK libraries
 The Visualization Toolkit (VTK) is an open-source software system
 for 3D computer graphics, image processing, and visualization.
 .
 This package provides the shared libraries needed to run C++ programs
 that use VTK.

Package: libvtk9-java
Architecture: amd64 arm64 armel armhf i386 loong64 mips64el mipsel ppc64el s390x alpha ia64 m68k powerpc ppc64 riscv64 sh4 sparc64 x32
Section: java
Depends: ${java:Depends},
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Suggests: java-virtual-machine,
          libvtk9-dev (= ${binary:Version}),
          vtk9-doc,
          vtk9-examples
Description: VTK - Java language support
 The Visualization Toolkit (VTK) is an object oriented, high level
 library that allows one to easily write C++ programs, Python and
 Java scripts that do 3D visualization.
 .
 This package provides the VTK Java language support.

Package: python3-vtk9
Architecture: any
Section: python
Depends: libvtk9.5 (= ${binary:Version}),
         python3-mpi4py,
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Suggests: mayavi2,
          vtk9-doc,
          vtk9-examples
Breaks: python3-vtk6,
        python3-vtk7
Replaces: python3-vtk6,
          python3-vtk7
Description: Python bindings for VTK
 The Visualization Toolkit (VTK) is an open-source software system
 for 3D computer graphics, image processing, and visualization.
 .
 This package provides the python3 bindings for VTK.

Package: vtk9
Architecture: any
Section: interpreters
Depends: libvtk9.5 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: vtk9-doc,
          vtk9-examples
Description: Binaries for VTK9
 The Visualization Toolkit (VTK) is an open-source software system
 for 3D computer graphics, image processing, and visualization.
 .
 This package provides binaries for VTK9

Package: vtk9-doc
Architecture: all
Section: doc
Depends: doc-base,
         libjs-jquery,
         libjs-mathjax,
         ${misc:Depends}
Suggests: libvtk9-dev,
          vtk9-examples
Description: VTK class reference documentation
 The Visualization Toolkit (VTK) is an open-source software system
 for 3D computer graphics, image processing, and visualization.
 .
 This package provides documentation for VTK9

Package: vtk9-examples
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Suggests: libvtk9-dev,
          python3,
          python3-vtk9,
          vtk9-doc
Description: VTK examples
 The Visualization Toolkit (VTK) is an open-source software system
 for 3D computer graphics, image processing, and visualization.
 .
 This package provides examples for VTK9

Package: libvtk9.5-qt
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Breaks: libvtk9.1-qt (<< ${source:Version})
Provides: ${t64:Provides}
Replaces: libvtk9.1-qt
Description: VTK libraries, Qt files
 The Visualization Toolkit (VTK) is an open-source software system
 for 3D computer graphics, image processing, and visualization.
 .
 This package provides the shared libraries needed to run C++ programs
 that use VTK. Qt files
X-Time64-Compat: libvtk9.1-qt

Package: libvtk9-qt-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libvtk9-dev (= ${binary:Version}),
         libvtk9.5-qt (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
         qt6-base-dev,
Description: VTK header files, containing Qt files
 The Visualization Toolkit (VTK) is an open-source software system
 for 3D computer graphics, image processing, and visualization.
 .
 This package provides the VTK header files required to compile
 C++ programs that use VTK to do 3D visualisation. Qt files

=== debian/rules ===
#!/usr/bin/make -f
BUILDDIR = $(CURDIR)/debian/build

include /usr/share/dpkg/architecture.mk

nojava_archs=hppa
nojava_os=hurd
ifeq (,$(filter $(DEB_BUILD_ARCH), $(nojava_archs))$(filter $(DEB_BUILD_ARCH_OS), $(nojava_os)))
  export JAVA_HOME=/usr/lib/jvm/default-java
  ifeq ($(DEB_HOST_ARCH),s390x)
    export JAVA_HOME=/usr/lib/jvm/java-17-openjdk-$(DEB_HOST_ARCH)
  endif
  extra_flags += -DVTK_WRAP_JAVA=ON
  # increase java version from 8 to 11 to remove many warnings
  extra_flags += -DVTK_JAVA_RELEASE_VERSION:STRING=11
endif

ifneq (,$(filter $(DEB_HOST_ARCH), armel m68k mips mipsel powerpc sh4))
  export DEB_CXXFLAGS_MAINT_APPEND += -Wl,--no-as-needed -latomic -Wl,--as-needed
  export DEB_LDFLAGS_MAINT_APPEND += -Wl,--no-as-needed -latomic -Wl,--as-needed
endif

notbb_archs=
notbb_os=hurd
ifeq (,$(filter $(DEB_BUILD_ARCH), $(notbb_archs))$(filter $(DEB_BUILD_ARCH_OS), $(notbb_os)))
  extra_flags += -DVTK_SMP_IMPLEMENTATION_TYPE:STRING="TBB"
else
  extra_flags += -DVTK_SMP_IMPLEMENTATION_TYPE:STRING="OpenMP"
endif

# Work around FTBFS on Alpha (assembler error "No lda !gpdisp!")
ifneq (,$(filter $(DEB_HOST_ARCH),alpha))
  export DEB_CXXFLAGS_MAINT_APPEND += -O1
endif

%:
	dh $@ --buildsystem=cmake --builddirectory=$(BUILDDIR)

extra_flags +=  \
	-DBUILD_SHARED_LIBS=ON \
	-DHDF5_IS_PARALLEL=OFF \
	-DVTK_BUILD_DOCUMENTATION=ON \
	-DVTK_BUILD_EXAMPLES=OFF \
	-DVTK_BUILD_TESTING=OFF \
	-DVTK_EXTRA_COMPILER_WARNINGS=ON \
	-DVTK_GROUP_ENABLE_Imaging:STRING=YES \
	-DVTK_GROUP_ENABLE_MPI:STRING=YES \
	-DVTK_GROUP_ENABLE_Qt:STRING=YES \
	-DVTK_GROUP_ENABLE_Rendering:STRING=YES \
	-DVTK_GROUP_ENABLE_StandAlone:STRING=YES \
	-DVTK_GROUP_ENABLE_Views:STRING=YES \
	-DVTK_MODULE_ENABLE_VTK_GUISupportQtQuick:STRING=DONT_WANT \
	-DVTK_MODULE_ENABLE_VTK_GUISupportQtSQL:STRING=NO \
	-DVTK_MODULE_ENABLE_VTK_InteractionImage:STRING=YES \
	-DVTK_MODULE_ENABLE_VTK_InteractionWidgets:STRING=YES \
	-DVTK_MODULE_ENABLE_VTK_IOGeoJSON:STRING=YES \
	-DVTK_MODULE_ENABLE_VTK_ParallelMPI:STRING=YES \
	-DVTK_MODULE_ENABLE_VTK_RenderingContextOpenGL2=YES \
	-DVTK_MODULE_ENABLE_VTK_RenderingExternal=YES \
	-DVTK_MODULE_ENABLE_VTK_RenderingQt:STRING=YES \
	-DVTK_MODULE_ENABLE_VTK_utf8:STRING=YES \
	-DVTK_MODULE_USE_EXTERNAL_VTK_doubleconversion:BOOL=ON \
	-DVTK_MODULE_USE_EXTERNAL_VTK_eigen:BOOL=ON \
	-DVTK_MODULE_USE_EXTERNAL_VTK_expat:BOOL=ON \
	-DVTK_MODULE_USE_EXTERNAL_VTK_freetype:BOOL=ON \
	-DVTK_MODULE_USE_EXTERNAL_VTK_gl2ps:BOOL=ON \
	-DVTK_MODULE_USE_EXTERNAL_VTK_hdf5:BOOL=ON \
	-DVTK_MODULE_USE_EXTERNAL_VTK_jpeg:BOOL=ON \
	-DVTK_MODULE_USE_EXTERNAL_VTK_jsoncpp:BOOL=ON \
	-DVTK_MODULE_USE_EXTERNAL_VTK_libproj:BOOL=ON \
	-DVTK_MODULE_USE_EXTERNAL_VTK_libxml2:BOOL=ON \
	-DVTK_MODULE_USE_EXTERNAL_VTK_lz4:BOOL=ON \
	-DVTK_MODULE_USE_EXTERNAL_VTK_lzma:BOOL=ON \
	-DVTK_MODULE_USE_EXTERNAL_VTK_netcdf:BOOL=ON \
	-DVTK_MODULE_USE_EXTERNAL_VTK_nlohmannjson:BOOL=ON \
	-DVTK_MODULE_USE_EXTERNAL_VTK_ogg:BOOL=ON \
	-DVTK_MODULE_USE_EXTERNAL_VTK_png:BOOL=ON \
	-DVTK_MODULE_USE_EXTERNAL_VTK_sqlite:BOOL=ON \
	-DVTK_MODULE_USE_EXTERNAL_VTK_theora:BOOL=ON \
	-DVTK_MODULE_USE_EXTERNAL_VTK_tiff:BOOL=ON \
	-DVTK_MODULE_USE_EXTERNAL_VTK_utf8:BOOL=ON \
	-DVTK_MODULE_USE_EXTERNAL_VTK_zlib:BOOL=ON \
	-DVTK_WRAP_PYTHON=ON \
	-DVTK_USE_MPI=ON \
	-DVTK_QT_VERSION=6

override_dh_auto_configure:
	dh_auto_configure -- $(extra_flags)

execute_after_dh_auto_clean:
	rm -rf $(BUILDDIR)

execute_after_dh_auto_build:
	cd $(BUILDDIR) && make DoxygenDoc
	find $(BUILDDIR)/Utilities/Doxygen/doc/html/ -name "*.md5" -delete

override_dh_auto_install:
	dh_auto_install -X.pyc -X.pyo
ifneq ($(JAVA_HOME),)
	mv $(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/java/vtk.jar $(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/java/vtk9.jar
endif
	sed -i -e "s/FATAL_ERROR/STATUS/g" $(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/cmake/vtk-9.5/VTK-targets.cmake

execute_after_dh_install:
	rm -rf $(CURDIR)/debian/tmp/usr/share/licenses
	find $(CURDIR)/debian/libvtk9-dev/ -name "*Qt*" -delete || true
	find $(CURDIR)/debian/libvtk9-dev/usr/include/ -name "Q*" -delete || true
	find $(CURDIR)/debian/libvtk9.5/ -name "*Qt*" -delete || true
	find $(CURDIR)/debian/tmp/usr/share/doc/vtk-9.5/doxygen -name "_formulas.log" -delete || true
	find $(CURDIR)/debian/build/Utilities/Doxygen/doc/html -name "_formulas.log" -delete || true

# Fix privacy breach
execute_after_dh_installdocs-indep:
	find $(CURDIR)/debian/vtk9-doc/ -type f -print0 | xargs -0 sed -i 's/https:\/\/raw\.githubusercontent\.com//g'
	find $(CURDIR)/debian/vtk9-doc/ -type f -print0 | xargs -0 sed -i 's/https:\/\/cdn\.jsdelivr\.net\/npm\/mathjax@2/\/usr\/share\/javascript\/mathjax/g'
